;;  Adding PG for AutoCAD r14 12/08/97
;; 15/07/99  AutoCAD r15 (2000)
;;-----------------------------------------------------------------
;; ----------------------------------------------------------------
;;                       
;;                 
;;   .                   
;;       "hidden" ( ).         
;;                                                                 
;;         ,            
;;        .                          
;;                                                                 
;;       ,   ,      
;;        .             
;;                                                               
;;             
;;        <RETURN>       
;;-----------------------------------------------------------------
;;     -  "" - < 1988                
;;   English version return by G.E.Pospelov -< 1993 .      
;;-----------------------------------------------------------------
;;--------- TRIMHALF.LSP  by G.E.Pospelov  < 1993 .
;;--------- CONCEAL.LSP   basic by Sinom Jones   < 1987 .
;;
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;---------------------------------------------------------------------------------------------
;;-----------> 24-09-2002 <--------------------------------------------------------------------
;;           kos@ring.by
;;        TRIMHALF.
;;     :
;;  1. trimhalf.lsp - ,     
;;   ($getLayerName currLayerName)   ,     .
;;  2. trimhalf.dcl -   ,       
;;      .      , 
;;       AutoCAD (    Support).
;;
;;------------------------------------------------------------------------
;;----------------  -  2003 --------------------
;;           vkle@saminfo.ru
;;    , , ,
;;          ,
;;      .
;;  trimhalf.lsp  trimhalf.dcl  .
;;------------------------------------------------------------------------

;;------------------------------------------------------------------------------
;;   
(defun $getLayerName (currLayerName / layerInfo listOfLayers pos dcl_id)
	(if	(< (setq dcl_id (load_dialog "trimhalf.dcl")) 0)
		(exit)
	) ;_  if
	(if	(not (new_dialog "trimhalf" dcl_id "" dcl_xy))
		(exit)
	) ;_  if

	;; ----    ,    ----
	(setq layerInfo (tblnext "LAYER" T))
	(while layerInfo
		(if	(/= 4 (logand 4 (cdr (assoc 70 layerInfo))))
			(setq listOfLayers (cons (cdr (assoc 2 layerInfo)) listOfLayers))
		) ;_  if
		(setq layerInfo (tblnext "LAYER"))
	) ;_ while
	(setq listOfLayers (acad_strlsort listOfLayers))
	;; ---- end ----

	;; ----         ----
	(if	(member currLayerName listOfLayers)
		(setq pos (vl-position currLayerName listOfLayers)) ;   
;;;		(setq pos 0)												;  -   
		(setq pos (vl-position "0" listOfLayers)) ;  -   "0"
	) ;_ if
	;; ---- end ----

	(start_list "listOfLayers")
	(mapcar 'add_list listOfLayers)
	(end_list)

	(set_tile "title" title)
	(set_tile "listOfLayers" (itoa pos))	;   ,
	(cond																	;    
		((= pm "_v")
		 (set_tile "view" "1")
		 (set_tile "ucs" "0")
		)
		(t
		 (set_tile "view" "0")
		 (set_tile "ucs" "1")
		)
	) ;_  cond
	(cond																	;     
		((= em "_e")
		 (set_tile "extend" "1")
		 (set_tile "noextend" "0")
		)
		(t
		 (set_tile "extend" "0")
		 (set_tile "noextend" "1")
		)
	) ;_  cond

	(action_tile "view" "(setq pm \"_v\")") ;   
	(action_tile "ucs" "(setq pm \"_u\")")
	(action_tile "extend" "(setq em \"_e\")")
	(action_tile "noextend" "(setq em \"_n\")")
	(action_tile "listOfLayers" "(setq pos (atoi (get_tile \"listOfLayers\")))") ;  
	(action_tile "accept" "(setq dcl_xy (done_dialog))") ;     

	(start_dialog)
	(unload_dialog dcl_id)

	(setq ln (nth pos listOfLayers))			;   
) ;_ defun

;;------------------------------------------------------------------------------
;; ERROR FUNCTION
(defun trimhalf_error	(msg)
	(if	(equal msg "Function cancelled")
		(princ "\n a \n")
		(princ "\n \n")
	) ;_  if
	(vla-endUndoMark doc)
	(if	endg
		(vl-cmdf "_.undo" 1)
	) ;_  if
	(vk_moder mode)
	(setq *error* olderr)
	(princ)
) ;_  defun

;;------------------------------------------------------------------------
;;     
;; Copyright DataCAD Group 1995-2000 .
(defun ic_assoc	(el lst / ls)
	;;  ,   ,  
	(setq ls (list))
	(foreach n lst
		(if	(or	(equal el (car n))
						(if	(and (= (type el) 'str) (= (type (car n)) 'str))
							(equal (strcase el) (strcase (car n)))
							nil
						) ;_  if
				) ;_  or
			(setq ls (cons n ls))
		) ;_  if
	) ;_  foreach
	(reverse ls)
) ;_  defun

(defun ic_getpolylist	(ent / lst c)
	;;     
	;; (ic_GetPolyList _) -  :
	;;  (
	;;	(_: (100 100 0) (200 100 0) ...)
	;;	          _: T  NIL 
	;;  )
	(setq ent (entget ent))
	(cond
		((= "LWPOLYLINE" (cdr (assoc 0 ent)))
		 (setq lst (mapcar 'cdr (ic_assoc 10 ent)))
		 (list lst (= 1 (logand 1 (cdr (assoc 70 ent)))))
		)
		((= "POLYLINE" (cdr (assoc 0 ent)))
		 (setq lst (list)
					 c	 (= 1 (logand 1 (cdr (assoc 70 ent))))
					 ent (entnext (cdr (assoc -1 ent)))
		 ) ;_  setq
		 (while	(progn (setq ent (entget ent)) (/= "SEQEND" (cdr (assoc 0 ent))))
			 (if (= "VERTEX" (cdr (assoc 0 ent)))
				 (setq lst (cons (cdr (assoc 10 ent)) lst))
			 ) ;_  if
			 (setq ent (entnext (cdr (assoc -1 ent))))
		 ) ;_  while
		 (list (reverse lst) c)
		)
		((= "LINE" (cdr (assoc 0 ent)))
		 (setq lst (cons (cdr (assoc 11 ent)) lst))
		 (setq lst (cons (cdr (assoc 10 ent)) lst))
		 (list lst nil)
		)
		(t
		 nil
		)
	) ;_  cond
) ;_  defun

;;------------------------------------------------------------------------
;;       WCS  UCS
;; lst -   
(defun vk_lst_wcs->ucs (lst)
	(mapcar '(lambda (x) (trans x 0 1)) lst)
) ;_  defun

;;------------------------------------------------------------------------
;;       OCS  UCS
;; lst -   
;; obj - ename   OCS
(defun vk_lst_ocs->ucs (lst obj)
	(mapcar '(lambda (x) (trans x obj 1)) lst)
) ;_  defun

;;------------------------------------------------------------------------
;;     lwpolyline   UCS
;; lst -    lwpolyline
;; obj - ename   OCS
(defun vk_lst_lw_ucs (lst obj / nl)
	(vl-cmdf "_.ucs" "_n" "_ob" obj)
	(setq	nl (mapcar '(lambda (x) (trans (list (car x) (cadr x)) 1 0))
									 (mapcar '(lambda (y) (trans y obj 1)) lst)
					 ) ;_  mapcar
	) ;_  setq
	(vl-cmdf "_.ucs" "_p")
	(mapcar '(lambda (x) (trans x 0 1)) nl)
) ;_  defun

;;------------------------------------------------------------------------
;;         
;;  3d      list1  list2.
;; 1e-9 -  
(defun vk_eq_lst_coord (list1 list2 / eqlist nl1 nl2 n1 n2)
	(setq nl1 0)
	(foreach n1	list1
		(setq nl2 0)
		(foreach n2	list2
			(if	(< (distance n1 n2) 1e-9)
				(setq eqlist (cons (list nl1 nl2) eqlist))
			) ;_  if
			(setq nl2 (1+ nl2))
		) ;_  repeat
		(setq nl1 (1+ nl1))
	) ;_  repeat
	(reverse eqlist)
) ;_  defun

;;------------------------------------------------------------------------
;;       UCS
;; (( ) ( )) .
;;      ,
;;      
(defun vk_se_spline_ucs	(obj / lst)
	(setq lst (mapcar 'cdr (ic_assoc 10 (entget obj))))
	(if	(< (distance (car lst) (last lst)) 1e-9)
		(setq lst (reverse (cdr (reverse lst)))) ;   
	) ;_  if
	(vk_lst_wcs->ucs (list (car lst) (last lst)))
) ;_  defun

;;------------------------------------------------------------------------
;;  ,   xpolyline xlwpolyline  xspline
;; pmt -      
;; oe4 - ename   
(defun th_trim&copy	()
	(setq pmt (getvar "LASTPROMPT"))
	(vla-put-layer (vla-copy (vlax-ename->vla-object oe1)) ln) ;   
	(setq oe4 (entlast))									;  -  
	(vla-put-visible (vlax-ename->vla-object oe4) 0) ;     
	(vl-cmdf "_.trim" ss "" "_p" pm "_e" em pts "")
	(vla-put-visible (vlax-ename->vla-object oe4) 1) ;    
) ;_  defun

;;------------------------------------------------------------------------
;;   lwpolyline
;; ss -    
;; e -       
;; ln -   
;; pm -   
;; em -    
(defun xlwpolyline (/ pts oe1 oe2 oe3 oe4 ptl1 ptl2 ptl3 cl eql12 pmt)
	(setq	oe1	 (car e)										;  
				pts	 (cadr e)										;   
				ptl1 (ic_getpolylist oe1)
				cl	 (cadr ptl1)								;    
				ptl1 (vk_lst_lw_ucs (car ptl1) oe1) ;     
	) ;_  setq
	(th_trim&copy)
	(setq oe3 (entlast))									;   -   
	(setq ptl2 (vk_lst_lw_ucs (car (ic_getpolylist oe1)) oe1)) ;   
	(setq eql12 (vk_eq_lst_coord ptl1 ptl2)) ;     
	(cond
		((equal e1 (entget oe1))						;   ...
		 (vla-put-layer (vlax-ename->vla-object oe1) ln) ; ... 
		 (entdel oe4)
		 (setq pmt (getvar "LASTPROMPT"))		;  
		)
		((not (equal pmt (getvar "LASTPROMPT")))) ; AutoCAD   TRIM...
		;;  ...
		(cl
		 (cond
			 ((< (distance (car ptl1) (car ptl2)) 1e-9) ;      
				(vl-cmdf "_.break" pts "_f" (last ptl2) "@")
				(entdel oe4)
			 )
			 ((< (distance (car ptl1) (last ptl2)) 1e-9) ;    
				(vl-cmdf "_.break" pts "_f" (car ptl2) "@")
				(entdel (entlast))
			 )
			 ((= (length ptl1) (length eql12)) ;   
				(vl-cmdf "_.break" pts "_f" (car ptl1) (last ptl2))
				(vl-cmdf "_.break" pts "_f" (car ptl2) (car ptl1))
			 )
			 ((< (caar eql12) (cadar eql12))	;      
				(vl-cmdf "_.break" pts "_f" (car ptl2) "@")
				(entdel (entlast))
				(vl-cmdf "_.break" pts "_f" (car ptl1) (last ptl2))
			 )
			 (t
				(vl-cmdf "_.break" pts "_f" (car ptl2) (last ptl2))
			 )
		 ) ;_ cond
		) ;_ cl
		;;  ...
		((not (equal oe4 oe3))							;    
		 (setq ptl3 (vk_lst_lw_ucs (car (ic_getpolylist oe3)) oe3)) ;  
		 (vl-cmdf "_.break" pts "_f" (car ptl2) (last ptl2))
		 (vl-cmdf "_.break" pts "_f" (car ptl3) (last ptl3))
		) ;_  new
		((< (distance (car ptl1) (car ptl2)) 1e-9) ;   
		 (vl-cmdf "_.break" pts "_f" (car ptl1) (last ptl2))
		)
		(t																	;   
		 (vl-cmdf "_.break" pts "_f" (car ptl2) (last ptl1))
		)
	) ;_  cond
	(equal pmt (getvar "LASTPROMPT"))			;   BREAK 
) ;_  defun

;;------------------------------------------------------------------------
;;   2D  3D 
;; ss -    
;; e -       
;; ln -   
;; pm -   
;; em -    
(defun xpolyline (/ 3d pts oe1 oe2 oe3 oe4 oe41 oe42 ptl1 ptl2 ptl3 cl pmt)
	(setq	oe1	 (car e)										;  
				3d	 (member "AcDb3dPolyline" (mapcar 'cdr (ic_assoc 100 (entget oe1))))
				pts	 (cadr e)										;   
				ptl1 (ic_getpolylist oe1)
				cl	 (cadr ptl1)								;    
	) ;_  setq
	(if	3d																;     
		(setq ptl1 (vk_lst_wcs->ucs (car ptl1)))
		(setq ptl1 (vk_lst_lw_ucs (car ptl1) oe1))
	) ;_  if
	(th_trim&copy)
	(if	(setq oe2 (entnext oe4))					;    
		(progn
			(while (/= (cdr (assoc 0 (entget (setq oe2 (entnext oe2))))) "SEQEND"))
			(if	(setq oe2 (entnext oe2))			;      ...
				(progn
					(if	3d												;       
						(setq ptl2 (vk_lst_wcs->ucs (car (ic_getpolylist oe2))))
						(setq ptl2 (vk_lst_lw_ucs (car (ic_getpolylist oe2)) oe2))
					) ;_  if 3d
					(setq oe3 oe2)								; ...    
					(while (/= (cdr (assoc 0 (entget (setq oe3 (entnext oe3))))) "SEQEND"))
					(if	(setq oe3 (entnext oe3))	;      
						(if	3d											;     
							(setq ptl3 (vk_lst_wcs->ucs (car (ic_getpolylist oe3))))
							(setq ptl3 (vk_lst_lw_ucs (car (ic_getpolylist oe3)) oe3))
						) ;_  if
					) ;_  if (entnext oe3)
				) ;_  progn
			) ;_  if (entnext oe2)
		) ;_  progn
	) ;_  if (entnext oe4)
	(cond
		((entget oe1)												;   ...
		 (vla-put-layer (vlax-ename->vla-object oe1) ln) ; ... 
		 (entdel oe4)
		 (setq pmt (getvar "LASTPROMPT"))		;  
		) ;_  oe1
		((not (equal pmt (getvar "LASTPROMPT")))) ; AutoCAD   TRIM...
		;;  ...
		((and cl oe3)												;    ( )
		 (vl-cmdf "_.break" pts "_f" (car ptl2) (last ptl2))
		 (vl-cmdf "_.break" pts "_f" (car ptl3) (last ptl3))
		 (if (not 3d)												; 3D    JOIN
			 (vl-cmdf "_.pedit" oe2 "_j" oe3 "" "")
		 ) ;_  if
		) ;_  oe3
		(cl
		 (vl-cmdf "_.break" pts "_f" (car ptl2) (last ptl2))
		 (setq oe41 (entnext oe2))					;    
		 (while (/= (cdr (assoc 0 (entget (setq oe41 (entnext oe41))))) "SEQEND"))
		 (if (setq oe42 (setq oe41 (entnext oe41)))
			 (progn														;     
				 (while (/= (cdr (assoc 0 (entget (setq oe42 (entnext oe42))))) "SEQEND"))
				 (if (and (setq oe42 (entnext oe42)) (not 3d)) ;    
					 (vl-cmdf "_.pedit" oe41 "_j" oe42 "" "")
				 ) ;_  if
			 ) ;_  progn
		 ) ;_  if
		)
		;;  ...
		(oe3																;    
		 (vl-cmdf "_.break" pts "_f" (car ptl2) (last ptl2))
		 (vl-cmdf "_.break" pts "_f" (car ptl3) (last ptl3))
		) ;_  new
		((< (distance (car ptl1) (car ptl2)) 1e-9) ;  
		 (vl-cmdf "_.break" pts "_f" (car ptl1) (last ptl2))
		)
		(t																	;   
		 (vl-cmdf "_.break" pts "_f" (car ptl2) (last ptl1))
		) ;_  t

	) ;_  cond
	(equal pmt (getvar "LASTPROMPT"))			;   BREAK 
) ;_  defun

;;------------------------------------------------------------------------
;;   spline
;; ss -    
;; e -       
;; ln -   
;; pm -   
;; em -    
(defun xspline (/ pts oe1 oe2 oe3 oe4 st1 se1 se2 se3 cl pmt)
	(setq	oe1	(car e)											;  
				pts	(cadr e)										;   
				cl	(= 1 (logand 1 (cdr (assoc 70 (entget oe1))))) ;   
				st1	(car (ic_assoc 10 (entget oe1)))
				se1	(vk_se_spline_ucs oe1)			;       UCS
	) ;_  setq
	(th_trim&copy)
	(setq oe3 (entlast))									;   -   
	(setq se2 (vk_se_spline_ucs oe1))			;     
	(cond
		((equal e1 (entget oe1))						;   ...
		 (vla-put-layer (vlax-ename->vla-object oe1) ln) ; ... 
		 (entdel oe4)
		 (setq pmt (getvar "LASTPROMPT"))		;  
		)
		((not (equal pmt (getvar "LASTPROMPT")))) ; AutoCAD   TRIM...
		;;  ...
		((and cl (member st1 (ic_assoc 10 (entget oe1)))) ;  
		 (vl-cmdf "_.break" pts "_f" (car se1) (last se2))
		 (vl-cmdf "_.break" pts "_f" (car se2) "@")
		 (entdel (entlast))
		)
		(cl																	;  
		 (vl-cmdf "_.break" pts "_f" (car se2) (last se2))
		)
		;;  ...
		((not (equal oe4 oe3))							;    
		 (setq se3 (vk_se_spline_ucs oe3))	;    
		 (vl-cmdf "_.break" pts "_f" (car se3) "@")
		 (entdel (entlast))
		 (vl-cmdf "_.break" pts "_f" (last se2) "@")
		 (entdel oe4)
		)
		((equal (car se1) (car se2))				;  
		 (vl-cmdf "_.break" pts "_f" (last se2) "@")
		 (entdel oe4)
		)
		(t																	;  
		 (vl-cmdf "_.break" pts "_f" (car se2) "@")
		 (entdel (entlast))
		)
	) ;_  cond
	(equal pmt (getvar "LASTPROMPT"))			;   BREAK 
) ;_  defun

;;------------------------------------------------------------------------
;;    2 
(defun xellipse	(/ e2 e3 e4 se1 ee1 se2 ee2)
	(vl-cmdf "_.TRIM" ss "" "_p" pm "_e" em (cadr e) "")
	(setq	e2	(entget (car e))
				e3	(entget (entlast))
				se1	(cdr (assoc 41 e1))
				ee1	(cdr (assoc 42 e1))
				se2	(cdr (assoc 41 e2))
				ee2	(cdr (assoc 42 e2))
	) ;_  setq
	(if	(equal e1 e2)											;    ?...
		(vla-put-layer (vlax-ename->vla-object (car e)) ln) ; ... 
		(progn															; ......
			(vla-put-layer (vla-copy (vlax-ename->vla-object (car e))) ln)
			(setq e4 (entget (entlast)))
			(if	(/= ee1 ee2)									; ...  
				(setq e4 (subst (cons 41 ee2) (assoc 41 e4) e4))
			) ;_  if
			(if	(/= se1 se2)									; ...  
				(setq e4 (subst (cons 42 se2) (assoc 42 e4) e4))
			) ;_  if
			(if	(not (equal el e3))						; ...   ?
				(if	(equal se1 se2)							; .      ?
					(setq e4 (subst (cons 42 (cdr (assoc 41 e3))) (assoc 42 e4) e4))
					(setq e4 (subst (cons 41 (cdr (assoc 42 e3))) (assoc 41 e4) e4))
				) ;_  if
			) ;_  if
			(entmod e4)
		) ;_  progn
	) ;_  if
) ;_  defun

;;------------------------------------------------------------------------
;;      3 
(defun xarc&line (/ e2 e3 e4 a b c d st en)
	(vl-cmdf "_.TRIM" ss "" "_p" pm "_e" em (cadr e) "")
	(setq e2 (entget (car e)))
	(if	(equal e1 e2)
		(vla-put-layer (vlax-ename->vla-object (car e)) ln)
		(progn
			(if	(= (cdr (assoc 0 e1)) "LINE")	;   ?
				(setq	st 10
							en 11
				) ;_  setq
				(setq	st 50
							en 51
				) ;_  setq
			) ;_  if
			(setq	e3 (entlast)
						a	 (cdr (assoc st e1))
						b	 (cdr (assoc en e1))
						c	 (cdr (assoc st e2))
						d	 (cdr (assoc en e2))
			) ;_  setq
			(vla-put-layer (vla-copy (vlax-ename->vla-object (car e))) ln)
			(setq e4 (entget (entlast)))
			(if	(equal el e3)
				(if	(equal a c)
					(entmod (subst (cons st d) (assoc st e4) (subst (cons en b) (assoc en e4) e4)))
					(entmod (subst (cons st a) (assoc st e4) (subst (cons en c) (assoc en e4) e4)))
				) ;_  if
				(entmod	(subst (cons st d)
											 (assoc st e4)
											 (subst (cons en (cdr (assoc st (entget e3)))) (assoc en e4) e4)
								) ;_  subst
				) ;_  entmod
			) ;_  if
		) ;_  progn
	) ;_  if
) ;_  defun

;;------------------------------------------------------------------------
;;    2 
(defun xcircle (/ e2)
	(vl-cmdf "_.TRIM" ss "" "_p" pm "_e" em (cadr e) "")
	(if	(equal e1 (entget (car e)))
		(vla-put-layer (vlax-ename->vla-object (car e)) ln)
		(progn
			(vla-put-layer (vla-copy (vlax-ename->vla-object (car e))) ln)
			(setq e2 (entget (entlast)))
			(entmod	(subst (cons 50 (cdr (assoc 51 e2)))
										 (assoc 50 e2)
										 (subst (cons 51 (cdr (assoc 50 e2))) (assoc 51 e2) e2)
							) ;_  subst
			) ;_  entmod
		) ;_  progn
	) ;_  if
) ;_  defun

;;------------------------------------------------------------------------
;;   
(defun xalert	()
	(vla-endUndoMark doc)
	(vl-cmdf "_.undo" 1)									;   
	(princ "\n*******************\n***   . ")
	(princ "     .")
) ;_  defun

;;;--------------------------------------------------------------------------
;;;   
;;; listvar -   
;;;  ,    (_1 _1 _2 _2 ....)
(defun vk_modes	(listvar / ms)
	(foreach n listvar (setq ms (cons (getvar n) (cons n ms))))
	(reverse ms)
) ;_  defun

;;;--------------------------------------------------------------------------
;;;   
;;; ms - ,    (_1 _1 _2 _2 ....)
(defun vk_moder	(ms)
	(while ms
		(setvar (car ms) (cadr ms))
		(setq ms (cddr ms))
	) ;_  while
) ;_  defun

;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
(defun C:TRIMHALF	(/ olderr mode vars doc nf ini ln title pm e el e1 ss dcl_xy endg)
	(setq	olderr	*error*
				*error*	trimhalf_error
				mode		(vk_modes	'("CMDECHO"			 "OSMODE"				"SNAPMODE"		 "BLIPMODE"
														"PROJMODE"		 "EDGEMODE"			"PICKFIRST"		 "UCSFOLLOW"
													 )
								) ;_  vk_modes
				vars		'("dcl_xy" "ln" "pm" "em")
				doc			(vla-get-activedocument (vlax-get-acad-object))
				nf			0
	) ;_  setq
	(vk_moder '("CMDECHO" 0 "OSMODE" 0 "SNAPMODE" 0 "BLIPMODE" 0 "UCSFOLLOW" 0 "PICKFIRST" 0))
	(if	(setq ini (vl-bb-ref 'trimhalf_ini)) ;     
		(foreach n vars											;   
			(set (read n) (car ini))
			(setq ini (cdr ini))
		) ;_  foreach
		(setq	ln		 (getvar "CLAYER")			;  -  
					dcl_xy '(-1 -1)								;     
					pm		 "_v"										;    
					em		 "_n"										;    
		) ;_  setq
	) ;_  if
	(setq endg t)
	(princ "\n  : ")
	(while (not	(setq	ss (ssget	'((-4 . "<OR")
																(0 . "LWPOLYLINE")
																(0 . "POLYLINE")
																(0 . "ARC")
																(0 . "CIRCLE")
																(0 . "ELLIPSE")
																(0 . "LINE")
																(0 . "VIEWPORT")
																(0 . "RAY")
																(0 . "REGION")
																(0 . "SPLINE")
																(0 . "TEXT")
																(0 . "XLINE")
																(-4 . "OR>")
															 )
											 ) ;_  ssget
							) ;_  setq
				 ) ;_  not
	) ;_  while
	;; ***    ***
	(while (progn
					 (if (= nf 0)
						 (initget " Settings")
						 (initget "  Settings Undo")
					 ) ;_  if
					 (vla-startUndoMark doc)			;    Undo
					 (princ	(strcat	"\n   "
													(if	(= pm "_v")
														" "
														" "
													) ;_  if
													".  "
													(if	(= em "_n")
														" "
														""
													) ;_  if
													"."
									) ;_  strcat
					 ) ;_  princ
					 (while	(= 4 (logand 4 (cdr (assoc 70 (tblsearch "LAYER" ln)))))
						 (setq title " !  ... ")
						 ($getLayerName ln)
						 (vl-bb-set 'trimhalf_ini (list dcl_xy ln pm em)) ;  
					 ) ;_  while
					 (setq endg	nil
								 e		(entsel	(strcat	"\n     \""
																			ln
																			"\"  ["
																			(if	(= nf 0)
																				""
																				"/"
																			) ;_  if
																			"] <!>: "
															) ;_  strcat
											) ;_  entsel
					 ) ;_  setq
				 ) ;_  progn
		(cond																;  
			((and (= (type e) 'STR) (member (strcase e) '("SETTINGS" "")))
			 (setq title "   ")
			 ($getLayerName ln)								;    ..
			 (vl-bb-set 'trimhalf_ini (list dcl_xy ln pm em)) ;  
			 (vla-endUndoMark doc)
			 (vl-cmdf "_.undo" 1)							;    
			)
			((and (= (type e) 'STR) (member (strcase e) '("UNDO" "")) (/= nf 0))
			 (vla-endUndoMark doc)
			 (vl-cmdf "_.undo" 2)							;      
			 (redraw)
			 (setq nf (1- nf))
			)
			((= (type (car e)) 'ENAME)				;   
			 (setq el (entlast))
			 (setq e1 (entget (car e)))
			 (cond														;  
				 ((= (boole 1 (cdr (assoc 70 (tblsearch "layer" (cdr (assoc 8 e1))))) 4) 4)
					(princ "\n .     .")
					(vla-endUndoMark doc)
					(vl-cmdf "_.undo" 1)					;    
				 )
				 ((member (cdr (assoc 0 e1)) '("LINE" "ARC"))
					(xarc&line)
					(setq endg t)
				 )
				 ((= (cdr (assoc 0 e1)) "CIRCLE")
					(xcircle)
					(setq endg t)
				 )
				 ((= (cdr (assoc 0 e1)) "ELLIPSE")
					(xellipse)
					(setq endg t)
				 )
				 ((= (cdr (assoc 0 e1)) "LWPOLYLINE")
					(if	(not (setq endg (xlwpolyline)))
						(xalert)
					) ;_  if
				 )
				 ((and (= (cdr (assoc 0 e1)) "POLYLINE")
;;;							 (/= 1 (logand 1 (cdr (assoc 70 e1)))) ;   
					) ;_  and
					(if	(not (setq endg (xpolyline)))
						(xalert)
					) ;_  if
				 )
				 ((= (cdr (assoc 0 e1)) "SPLINE")
					(if	(not (setq endg (xspline)))
						(xalert)
					) ;_  if
				 )
				 (t (prompt "\n ."))
			 ) ;_  cond  
			 (if endg													;   
				 (progn
					 (setq nf (1+ nf))
					 (vla-endUndoMark doc)
				 ) ;_  progn
			 ) ;_  if
			) ;_   
		) ;_  cond  
	) ;_  while
	;; ***   ***
	(vla-endUndoMark doc)
	(if	(not endg)
		(vl-cmdf "_.undo" 1)								;   
	) ;_  if
	(vk_moder mode)
	(setq *error* olderr)
	(princ)
) ;_  defun
;;;-------------------------------------------------------------------
(vl-load-com)
(princ "\n   : TRIMHALF")

 ;|Visual LISP Format Options
(96 2 40 2 T " " 96 9 0 0 0 T T nil T)
;*** DO NOT add text below the comment! ***|;
